POj 2104 K-th Number (分桶法+线段树)
Description
You are working for Macrohard company in data structures department. After failing your previous task about key insertion you were asked to write a new data structure that would be able to return quickly k-th order statistics in the array segment.
That is, given an array a[1...n] of different integer numbers, your program must answer a series of questions Q(i, j, k) in the form: "What would be the k-th number in a[i...j] segment, if this segment was sorted?"
For example, consider the array a = (1, 5, 2, 6, 3, 7, 4). Let the question be Q(2, 5, 3). The segment a[2...5] is (5, 2, 6, 3). If we sort this segment, we get (2, 3, 5, 6), the third number is 5, and therefore the answer to the question is 5.
Input
The first line of the input file contains n --- the size of the array, and m --- the number of questions to answer (1 <= n <= 100 000, 1 <= m <= 5 000).
The second line contains n different integer numbers not exceeding 109 by their absolute values --- the array for which the answers should be given.
The following m lines contain question descriptions, each description consists of three numbers: i, j, and k (1 <= i <= j <= n, 1 <= k <= j - i + 1) and represents the question Q(i, j, k).
Output
For each question output the answer to it --- the k-th number in sorted a[i...j] segment.
Sample Input
7 3
1 5 2 6 3 7 4
2 5 3
4 4 1
1 7 3
Sample Output
5
6
3
题意:
给定一个数列a1,a2,a3,···,an和m个三元组表示的查询。对于每个查询(i,j,k),输出ai,ai+1,···,aj的升序排列中第k个数。
分析:
因为查询的个数m很大,朴素的求法没法在规定的时间内求出。
如果x是第k个数,那么一定有:
1.在区间中不超过x的数不少于k个
2.在区间中小于x的数不到k个
因此,如果可以快速求出区间里不超过x的数的个数,就可以通过对x进行二分搜索求出第k个数是多少。
接下来,我们来看一下如何计算在某个区间里不超过x的数的个数。如果不进行预处理,那么就只能遍历一遍所有的元素。
另一方面,如果区间是有序的,那么就可以通过二分搜索法高效地求出不超过x的数的个数了。但是,如果对于每个查询都分别进行一次排序,就完全无法降低复杂度。所以,可以考虑使用平方分割和线段树进行求解。
首先看一下如何使用平方分割来解决这个问题。把数列每b个一组分到哥哥桶里,每个桶内保存有序后的序列。这样,如果要求在某个区间中不超过x的个数,就可以这样求得:
1.对于完全包含在区间内的桶,用二分搜索法进行计算
2.对于所在的桶不完全包含在区间内的元素,逐个检查。
#include<cstdio>
#include<iostream>
#include<string.h>
#include<vector>
#include<algorithm>
using namespace std;
typedef long long ll;
const int B = 1072;
const int maxn = 1e5+5;
int n, m;
int a[maxn], num[maxn];///原序列和排序后的序列
vector<int> buk[maxn/B+1];///每个桶排序后的结果
int main()
{
scanf("%d%d",&n,&m);
for(int i = 0; i < n; i++)
{
scanf("%d", a+i);
buk[i/B].push_back(a[i]);
}
memcpy(num,a,sizeof(int)*n);
sort(num,num+n);
///(n-1)/b <= n/b 当 n%b != 0时候取等号,这时候不是一个完整的桶,所以最后一个桶不sort也没关系
for(int i = n/B;i>=0; i--) sort(buk[i].begin(),buk[i].end());
while(m--)
{
int l,r,k;
scanf("%d%d%d",&l,&r,&k);
int lb = 0, ub = n-1;
while(lb < ub)
{
int md = (lb+ub)>>1;
int x = num[md];
///求[l,r)区间中第k个数
int p = l-1, q = r, c = 0;
///区间两端多出的部分
while(p<q && p%B) if(a[p++] <= x) c++;
while(p<q && q%B) if(a[--q] <= x) c++;
///对每一个桶进行计算
for(int i = p/B, mi = q/B; i < mi; i++)
{
c += upper_bound(buk[i].begin(),buk[i].end(),x)-buk[i].begin();
}
c >= k?ub = md: lb = md+1;
}
printf("%d\n", num[lb]);
}
return 0;
}
思路同上,只是计算cnt的时候改用线段树。线段树每个结点保存有序的数组,建树过程是归并排序的完整再现,因此也叫归并树。
更抽象来看,数值大小和位置是两个维度,查询就是询问一个空间内的点数,也就是所谓的区域树了,通过嵌套可以推广到高维。
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<queue>
#include<vector>
#include<stack>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
using namespace std;
typedef long long ll;
#define para int d = 0, int l = 0,int r = n
#define lsn d+1, l, mid
#define rsn d+1, mid, r
#define insd ql<=l&&r<=qr
const int maxn = 1e5;
int n, m;
int a[maxn];
const int Log2N_ = 18;
int dat[Log2N_][maxn];
void build(para)
{
if(r-l == 1)
{
dat[d][l] = a[l];
}
else
{
int mid = (l+r)>>1;
build(lsn);
build(rsn);
merge(dat[d+1]+l,dat[d+1]+mid,dat[d+1]+mid,dat[d+1]+r,dat[d]+l);
}
}
int ql, qr, qval;
int query(para)
{
if(insd)
{
return upper_bound(dat[d]+l,dat[d]+r,qval) - dat[d]-l;
}
else
{
int res = 0;
int mid = (l+r)>>1;
if(ql<mid) res += query(lsn);
if(qr>mid) res += query(rsn);
return res;
}
}
int main()
{
scanf("%d%d",&n,&m);
for(int i = 0; i < n; i++)
{
scanf("%d", a+i);
}
build();
while(m--)
{
int k;
scanf("%d%d%d",&ql,&qr,&k);
ql--;
int lb = 0, ub = n-1;
while(lb < ub)
{
int md = (lb+ub)>>1;
qval = dat[0][md];
query() >= k? ub = md:lb = md+1;
}
printf("%d\n", dat[0][lb]);
}
return 0;
}
POj 2104 K-th Number (分桶法+线段树)的更多相关文章
- POJ 2104 K-th Number(分桶,线段树,主席树)
一道比较经典的数据结构题.可以用多种方式来做. 一,分桶法(平方分解). 根据数字x的大小和区间内不大于x的数字数量cnt的单调性,可知第k大数kth对应的cnt应该满足cnt≥k, 且kth是满足条 ...
- 静态区间第k大(分桶法和平方分割)
POJ 2104为例 思想: <挑战程序设计竞赛>中介绍的方法. 分桶法:把一排物品或者平面分成桶,每个桶分别维护自己内部的信息,已达到高效计算的目的. 设一共有n个数,每b个分到一个桶里 ...
- LeetCode 220. Contains Duplicate III (分桶法)
Given an array of integers, find out whether there are two distinct indices i and j in the array suc ...
- 【POJ 2482】 Stars in Your Window(线段树+离散化+扫描线)
[POJ 2482] Stars in Your Window(线段树+离散化+扫描线) Time Limit: 1000MS Memory Limit: 65536K Total Submiss ...
- poj 3468:A Simple Problem with Integers(线段树,区间修改求和)
A Simple Problem with Integers Time Limit: 5000MS Memory Limit: 131072K Total Submissions: 58269 ...
- POJ.3468 A Simple Problem with Integers(线段树 区间更新 区间查询)
POJ.3468 A Simple Problem with Integers(线段树 区间更新 区间查询) 题意分析 注意一下懒惰标记,数据部分和更新时的数字都要是long long ,别的没什么大 ...
- POJ 2104 K-th Number (可持久化线段树)
题目大意 给一个长度为n的序列,有m个询问,每次询问一个区间里面第k小的数. 解题分析 静态的区间第k大.复习了一下可持久化线段树. 首先对数值离散化,建一颗权值线段树.按照序列的顺序依次插入,每一个 ...
- poj 3468 A Simple Problem with Integers(线段树、延迟更新)
A Simple Problem with Integers Time Limit: 5000MS Memory Limit: 131072K Total Submissions: 74705 ...
- poj 3468 A Simple Problem with Integers(线段树+区间更新+区间求和)
题目链接:id=3468http://">http://poj.org/problem? id=3468 A Simple Problem with Integers Time Lim ...
随机推荐
- iOS-UISearchController用法
import "ViewController.h" @interface ViewController ()<UITableViewDelegate,UITableViewD ...
- PAT 甲级 1012 The Best Rank
https://pintia.cn/problem-sets/994805342720868352/problems/994805502658068480 To evaluate the perfor ...
- cacti添加多个tomcat监控(多端口)
1.修改tomcat的模版 Data Input Methods->Tomcat Status 把原本固定的端口,用户名和密码手动修改成变量(绿线标出的),之后save保存之后,再在Input ...
- 【其他】VS提示不一致的行尾
应该是用不同的编辑器或平台编辑过同一个文件,比如Windows是\r\n,有的系统只有一个\n, 需要都统一,否则代码可能会堆成一堆.
- bzoj3864-hdu4899-Hero meet devil
题目 给出一个由AGTC组成的字符串\(S\),长度为\(n\),对于每个\(i\in [0,n]\),问有多少个长度为\(m\),仅含有AGTC的字符串\(T\)使得\(S\)与\(T\)的最长公共 ...
- 【bzoj2938】[Poi2000]病毒 AC自动机
题目描述 二进制病毒审查委员会最近发现了如下的规律:某些确定的二进制串是病毒的代码.如果某段代码中不存在任何一段病毒代码,那么我们就称这段代码是安全的.现在委员会已经找出了所有的病毒代码段,试问,是否 ...
- 【BZOJ5301】【CQOI2018】异或序列(莫队)
[BZOJ5301][CQOI2018]异或序列(莫队) 题面 BZOJ 洛谷 Description 已知一个长度为 n 的整数数列 a[1],a[2],-,a[n] ,给定查询参数 l.r ,问在 ...
- POJ2299:Ultra-QuickSort——题解
http://poj.org/problem?id=2299 题目大意:给一串数,求其按照两两交换排序最少排几次. 求逆序对裸题,不建议用数据结构(因为需要离散化) #include<cstdi ...
- 【博弈论】Nim游戏
百度百科 Definition 这样的游戏被称为Nim游戏: 1.有两个玩家,轮流进行操作 2.是公平游戏.即面对同一局面两个玩家所能进行的操作是相同的.例如中国象棋不是公平游戏.因为面对同一个局面, ...
- Codeforces Round #544 (Div. 3) 题解
Codeforces Round #544 (Div. 3) D. Zero Quantity Maximization 题目链接:https://codeforces.com/contest/113 ...